<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "waiting_room_invite".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "WaitingRoomInvite".
 *
 * Columns in table "waiting_room_invite" available as properties of the model,
 * followed by relations of table "waiting_room_invite" available as properties of the model.
 *
 * @property integer $id
 * @property integer $waiting_room_setting_id
 * @property string $guid
 * @property integer $patient_id
 * @property string $patient_nickname
 * @property string $patient_first_name
 * @property string $patient_last_name
 * @property string $patient_phone_number
 * @property string $patient_email
 * @property integer $added_by_account_id
 * @property string $date_added
 * @property string $invite_sent
 * @property integer $review_request_id
 * @property integer $send_review_request
 * @property integer $overall_rating
 * @property integer $review_request_complete
 * @property integer $review_request_reminder_sent
 * @property integer $enabled
 * @property integer $scheduling_mail_id
 * @property integer $is_static
 *
 * @property WaitingRoomSetting $waitingRoomSetting
 * @property WaitingRoomQueue[] $waitingRoomQueues
 */
abstract class BaseWaitingRoomInvite extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'waiting_room_invite';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'WaitingRoomInvite|WaitingRoomInvites', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {

        return array(
            array(
                'waiting_room_setting_id, guid, patient_nickname, added_by_account_id, date_added',
                'required'
            ),
            array(
                'waiting_room_setting_id, added_by_account_id, review_request_id, send_review_request,
                review_request_complete, review_request_reminder_sent, overall_rating, patient_id, enabled,
                scheduling_mail_id, is_static',
                'numerical', 'integerOnly' => true
            ),
            array('guid', 'length', 'max' => 36),
            array('patient_nickname', 'length', 'max' => 51),
            array('patient_phone_number', 'length', 'max' => 14),
            array('patient_email, patient_first_name, patient_last_name', 'length', 'max' => 255),
            array('patient_phone_number, patient_email, invite_sent', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, waiting_room_setting_id, guid, patient_nickname, patient_phone_number, patient_email,
                added_by_account_id, date_added, review_request_id, send_review_request, review_request_complete,
                review_request_reminder_sent, patient_first_name, patient_last_name, overall_rating, invite_sent,
                enabled, scheduling_mail_id, is_static',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'waitingRoomSetting' => array(self::BELONGS_TO, 'WaitingRoomSetting', 'waiting_room_setting_id'),
            'waitingRoomQueues' => array(self::HAS_MANY, 'WaitingRoomQueue', 'waiting_room_invite_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'waiting_room_setting_id' => null,
            'guid' => Yii::t('app', 'Guid'),
            'patient_id' => Yii::t('app', 'Patient ID'),
            'patient_nickname' => Yii::t('app', 'Patient Nickname'),
            'patient_first_name' => Yii::t('app', 'Patient First Name'),
            'patient_last_name' => Yii::t('app', 'Patient Last Name'),
            'patient_phone_number' => Yii::t('app', 'Patient Phone Number'),
            'patient_email' => Yii::t('app', 'Patient Email'),
            'added_by_account_id' => Yii::t('app', 'Added By Account'),
            'date_added' => Yii::t('app', 'Date Added'),
            'review_request_id' => Yii::t('app', 'Review Request ID'),
            'send_review_request' => Yii::t('app', 'Send Review Request'),
            'overall_rating' => Yii::t('app', 'Overall Rating'),
            'review_request_complete' => Yii::t('app', 'Review Request Complete'),
            'review_request_reminder_sent' => Yii::t('app', 'Review Request Reminder Sent'),
            'waitingRoomSetting' => null,
            'waitingRoomQueues' => null,
            'invite_sent' => null,
            'enabled' => null,
            'scheduling_mail_id' => null,
            'is_static' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('waiting_room_setting_id', $this->waiting_room_setting_id);
        $criteria->compare('patient_id', $this->patient_id, true);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('patient_nickname', $this->patient_nickname, true);
        $criteria->compare('patient_phone_number', $this->patient_phone_number, true);
        $criteria->compare('patient_email', $this->patient_email, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('patient_first_name', $this->patient_first_name, true);
        $criteria->compare('patient_last_name', $this->patient_last_name, true);
        $criteria->compare('send_review_request', $this->send_review_request, true);
        $criteria->compare('overall_rating', $this->overall_rating, true);
        $criteria->compare('review_request_complete', $this->review_request_complete, true);
        $criteria->compare('review_request_reminder_sent', $this->review_request_reminder_sent, true);
        $criteria->compare('invite_sent', $this->invite_sent, true);
        $criteria->compare('enabled', $this->enabled, true);
        $criteria->compare('scheduling_mail_id', $this->scheduling_mail_id, true);
        $criteria->compare('is_static', $this->is_static, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }
}
